<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Annotation Overview</TITLE>
<link href="suif1_71.html" rel=Next>
<link href="suif1_69.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_69.html">previous</A>, <A HREF="suif1_71.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC70" HREF="suif1_toc.html#TOC70">Overview</A></H2>

<P>
<A NAME="IDX544"></A>
<A NAME="IDX545"></A>
<A NAME="IDX546"></A>
Annotations are represented by <CODE>annote</CODE> objects which are
implemented in the files <TT>`annote.h'</TT> and <TT>`annote.cc'</TT>.  Each
annotation contains two fields: a name and a data pointer.  The name is
a character string that must be entered in the <CODE>lexicon</CODE>.
See section <A HREF="suif1_102.html#SEC102">Lexicon</A>.  The name serves to identify the purpose of the
annotation, and with the help of the annotation manager, it specifies
the format of the associated data.  The <CODE>set_name</CODE> method can be
used to change the name of an annotation, but in most cases it's easier
to just create a new annotation.

</P>
<P>
As a convention, each annotation name should have a global variable that
is a pointer to its entry in the <CODE>lexicon</CODE>.  The names of these
variables should be <CODE>k_</CODE> followed by the annotation name.  For
example, <CODE>k_repeat_init</CODE> is a global variable defined in the
library to point to the <CODE>"repeat_init"</CODE> annotation name.  Because
the annotation names are always in the <CODE>lexicon</CODE>, you can just
compare the names with the global variables instead of performing string
comparisons.  For example:

</P>

<PRE>
annote *an;
if (an-&#62;name() == k_repeat_init) {
    an-&#62;print();
}
</PRE>

<P>
<A NAME="IDX547"></A>
<A NAME="IDX548"></A>
<A NAME="IDX549"></A>
<A NAME="IDX550"></A>
The data field in an annotation is a <CODE>void*</CODE> pointer so that, with
the appropriate type cast, it can refer to any data structure.  The
<CODE>data</CODE> and <CODE>set_data</CODE> methods may be used to directly access
an annotation's data field.  The <CODE>immeds</CODE> and <CODE>set_immeds</CODE>
methods also provide access to the data in an annotation, but only if it
can be represented by a list of <CODE>immed</CODE> values; this is described
in more detail below for each kind of annotation.

</P>
<P>
<A NAME="IDX551"></A>
The <CODE>print</CODE> method prints an annotation to the specified file.  The
format depends on the kind of annotation.  Flat annotations are printed
as lists of <CODE>immed</CODE> values.  For unregistered annotation, the
contents of the data field are printed directly as a pointer value (a
hexidecimal representation on most systems).  Structured annotations
may have user-defined printing functions registered in the annotation
manager; if such a function is defined, the library uses it.  If no
printing function is defined but a function to convert to a flat
<CODE>immed</CODE> list is defined, that is used to temporarily convert to
flat lists and print as such.  If neither a printing nor a conversion
function is provided, the printing is done as with unregistered
annotations.

</P>
<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_69.html">previous</A>, <A HREF="suif1_71.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
